#Region ;**** Anweisungen an die AutoIt-GUI ****
#AutoIt3Wrapper_Icon=icon\law.ico
#AutoIt3Wrapper_Compression=4
#AutoIt3Wrapper_Compile_Both=n
#AutoIt3Wrapper_UseX64=Y
#AutoIt3Wrapper_UseUpx=N
#AutoIt3Wrapper_Res_Language=1031
#EndRegion ;**** --- ****

#Region ;**** Verweise setzen ****
#include <APIShellExConstants.au3>
#include <Excel.au3>
#include <FileConstants.au3>
#include <GUIConstantsEx.au3>
#include <GuiImageList.au3>
#include <GuiTreeView.au3>
#include <GuiToolbar.au3>
#include <GuiToolTip.au3>
#include <TreeViewConstants.au3>
#include <WinAPI.au3>
#include <WinAPIFiles.au3>
#include <WinAPIIcons.au3>
#include <WinAPIRes.au3>
#include <WinAPIShellEx.au3>
#include <WinAPIShPath.au3>
#include <WindowsConstants.au3>
#include <Word.au3>
#include <settings\Ribbon.au3>
#EndRegion ;**** --- ****

#Region ;**** Globale Variablen definieren und füllen ****
    Global $aSize, $g_hToolbar, $g_idMemo, $g_iItem, $iIconCount, $hImage, $count, $iButtonText, $iButtonCount ; Hier werden globale Variablen deklariert
    Global Const $sSearchDir = @ScriptDir ; Hier wird der Startpfad angegeben
	Global Const $sExcludeDirs = 'icon;settings;toolbars;start;Projektbeschreibung' ; Hier die Ordner angeben, die nicht eingelesen werden sollen
    Global Const $sFileExtensions = '*.pdf;*.docx;*.xlsm' ; Hier die Dateitypen angeben, die eingelesen werden sollen
    Global $SprachID = IniRead(@ScriptDir & "\settings\settings.ini", "KRWD", "lang", "de")
    Global $SetToolButtonText[10] ; Anzahl der Schaltflächen
	Global Const $GetToolButtonText[20] = ["Datei öffnen", "Ordner zuklappen", "Ordner aufklappen", "Seite zurück", _
	                                       "Seite vorwärts", "Seite neu laden", "Laden abbrechen", "Einstellungen", _
								           "Hilfe", "Beenden", "File Open", "Order up", "Order down", "Back", "Forward", _
								           "Refresh", "Stop", "Settings", "Help", "Exit"] ; Die Scahtlfächenbeschriftungen in Reihenfolge ihrer Nutzung

   #Region ;**** Variablen für Iconliste füllen ****
       Global Const $bLargeIcons = False
       Global $hlibary = @ScriptDir & "\icon\icons.dll"
       Global $mPathMap[]
       _WinAPI_FileIconInit()
       Global $hSystemImgList = _WinAPI_ShellGetImageList(Not $bLargeIcons)
       Global $hBusyCur = _WinAPI_LoadCursorFromFile(@WindowsDir & '\Cursors\aero_busy_xl.ani')
   #EndRegion ;**** --- ****

   #Region ;**** Dialog erstellen ****
       Global $hMainGui = GUICreate('Konzernregelwerke', 1700, 1000, -1, -1)
   #EndRegion ;**** --- ****

 #Region ;**** Menüband erstellen
    Global $hRibInstance = _WinAPI_LoadLibraryEx(".\icon\lib.dll", 2)
    Global $sResName = "APP_RIBBON"
    Global $oRibbFramework, $oApp
    ; ... plus array of few more
    Global $oHandlers[1][2] ; Array of handlers (objects)
    _Ribbon_Create($hMainGUI, $hRibInstance, $sResName, $oRibbFramework, $oApp, $oHandlers)
#EndRegion ;**** --- ****

;~    #Region ;**** Symbolleiste erstellen ****
;~        Global $g_hToolbar = _GUICtrlToolbar_Create($hMainGui)
;~        Global $aSize = _GUICtrlToolbar_GetMaxSize($g_hToolbar)
;~ 	  #EndRegion ;**** --- ****

   #Region ;**** WebBrowser-Control erstellen ****
       Global Const $oIE = ObjCreate("Shell.Explorer.2")
       Global Const $GUIActiveX = GUICtrlCreateObj ($oIE, 372, 150, 1300, 830)
   #EndRegion ;**** --- ****

   #Region ;**** Verzeichnisbaum (Treeview) erstellen ****
       Global $idTreeview = GUICtrlCreateTreeView(6, 150, 361, 830, $GUI_SS_DEFAULT_TREEVIEW, $WS_EX_CLIENTEDGE)
       GUICtrlSetFont(-1, 10 + $bLargeIcons, 400, 0, 'Calibri')
       GUICtrlSetResizing(-1, $GUI_DOCKBOTTOM + $GUI_DOCKTOP + $GUI_DOCKLEFT)
       _GUICtrlTreeView_SetNormalImageList($idTreeview, $hSystemImgList)
       Global $hRoot = _CreateRoot($idTreeview, $sSearchDir, $bLargeIcons)
   #EndRegion ;**** Ende Treeview ****

#EndRegion ;**** --- ****

;~ #Region ;**** Iconliste aus DLL füllen ****
;~    $hImage = _GUIImageList_Create(24, 24, 5, 3)
;~    $count = _WinAPI_ExtractIconEx($hlibary, -1, 0, 0, 0)
;~         For $iIconCount = 0 to $count -1
;~             _GUIImageList_AddIcon($hImage, $hlibary, $iIconCount)
;~         Next
;~             _GUICtrlToolbar_SetImageList($g_hToolbar, $hImage)
;~ 		    _GUICtrlToolbar_AddBitmap($g_hToolbar, 1, -1, $IDB_STD_LARGE_COLOR)
;~ #EndRegion :**** --- ****

;~ #Region ;**** Iconbeschriftung erstellen ****
;~     For $iButtonText = 0 To 9
;~ 		$SetToolButtonText[$iButtonText] = _GUICtrlToolbar_AddString($g_hToolbar, ($sprachID = "de") ? $GetToolButtonText[$iButtonText] : $GetToolButtonText[$iButtonText + 10])
;~ 	Next
;~ #EndRegion ;**** --- ****

;~ #Region ;**** Symbolleiste füllen ****
;~      Local $iView = _GUICtrlToolbar_AddBitmap($g_hToolbar, 1, -1, 5)
;~ 	 For $iButtonCount = 0 To 9
;~ 		 If $iButtonCount = 1 Or $iButtonCount = 3 Or $iButtonCount = 7 Then _GUICtrlToolbar_AddButtonSep($g_hToolbar)
;~ 		 _GUICtrlToolbar_AddButton($g_hToolbar, $iButtonCount + 1000, $iButtonCount, $SetToolButtonText[$iButtonCount])
;~ 	 Next
;~ #EndRegion ;**** --- ****

#Region ;**** Dialog anzeigen ****
    GUISetState(@SW_SHOW, $hMainGui)
#EndRegion ; **** --- ****

#Region ;**** Meldungen für Dialog registrieren ****
    GUIRegisterMsg($WM_NOTIFY, '_WM_Notify')
    GUIRegisterMsg(0x0014, "WM_ERASEBKGND")
#EndRegion ;**** --- ****

#Region ;**** Cursor setzen ****
    Global $hOldCur = _WinAPI_SetCursor($hBusyCur ? $hBusyCur : 9)
    _WinAPI_SetCursor($hOldCur)
#EndRegion ;**** --- ****

#Region ;**** Verzeichnisbaum (Treeview) füllen ****
    _GUICtrlTreeView_BeginUpdate($idTreeview)
    _ReadDirectory($idTreeview, $hRoot, $sSearchDir, $bLargeIcons)
    _GUICtrlTreeView_EndUpdate($idTreeview)
#EndRegion ;**** --- ****

#Region ;**** WebBrowser füllen ****
    $oIE.navigate(@ScriptDir & "\start\startseite.pdf")
    _SendMessage(GUICtrlGetHandle($idTreeview), $TVM_EXPAND, $TVE_EXPAND, $hRoot, 0, 'wparam', 'handle')
#EndRegion ;**** Ende WebBrowser ****



#Region ;**** Abfangen des Schließkreuzes ****
     While 1
          Switch GUIGetMsg()
                 Case $GUI_EVENT_CLOSE
				 ExitLoop
		Case $GUI_EVENT_CLOSE
			_Ribbon_Destroy($oRibbFramework, $oApp, $oHandlers)
			Exit
		  EndSwitch
	 WEnd


GUIDelete()
#EndRegion ;**** --- ****

Func MY_WM_SIZE($hWnd, $msg, $wParam, $lParam)
	Return 0
EndFunc   ;==>MY_PAINT



Func WM_ERASEBKGND($hWnd, $msg, $wParam, $lParam)
    Return 1
EndFunc
#Region ;**** Auszuführende Aktionen ****
Func _WM_Notify($hWnd, $iMsg, $iwParam, $ilParam)
    #forceref $hWnd, $iMsg, $iwParam

    _Treeview_Actions($ilParam)
   ; _Toolbar_Actions($ilParam)
EndFunc
#EndRegion ;**** --- ****

#Region ;**** Treewiew Actions ****
Func _Treeview_Actions($ilParam)

    Local $tNMTREEVIEW, $tNMHDR, $hItem, $hWndFrom, $sPath
    Local $sSepChar = Opt('GUIDataSeparatorChar')
	$iCode = DllStructGetData($tNMHDR, "Code")
    $tNMTREEVIEW = DllStructCreate($tagNMTREEVIEW, $ilParam)
    $hWndFrom = DllStructGetData($tNMTREEVIEW, 'hWndFrom')

    Switch $hWndFrom
        Case GUICtrlGetHandle($idTreeview)
            Switch DllStructGetData($tNMTREEVIEW, 'Code')
                Case $TVN_SELCHANGEDA, $TVN_SELCHANGEDW
                    $hItem = DllStructGetData($tNMTREEVIEW, 'NewhItem')
                    If $hItem Then
                        $sPath = $mPathMap[$hItem]
                        If StringRight($sPath, 3) = "pdf" Then
		                   $oIE.navigate($sPath)
                        ElseIf  StringRight($sPath, 4) = "xlsx" Or StringRight($sPath, 4) = "xlsm" Then
							    Local $oExcel = _Excel_Open()
    	                        Local $sWorkbook = $sPath
                                _Excel_BookOpen($oExcel, $sWorkbook)
                        ElseIf  StringRight($sPath, 4) = "docx" Or StringRight($sPath, 4) = "docm" Then
		                        Local $oWord = _Word_Create()
    	                        Local $sWordDoc = $sPath
                                _Word_DocOpen($oWord, $sWordDoc)
						EndIF
                    EndIf
			EndSwitch
	EndSwitch

EndFunc
#EndRegion ;**** --- ****

#Region ;**** Toolbar Actions ****
Func _Toolbar_Actions($ilParam)

        Local $tNMHDR, $hWndFrom, $iCode, $iNew, $iFlags, $iOld
        Local $tNMTBHOTITEM
              $tNMHDR = DllStructCreate($tagNMHDR, $ilParam)
              $hWndFrom = DllStructGetData($tNMHDR, "hWndFrom")
              $iCode = DllStructGetData($tNMHDR, "Code")
        Switch $hWndFrom
			   Case $g_hToolbar
					Switch $iCode
						   Case $NM_LDOWN
								If $g_iItem = "1000"  Then
								   Global $sFile = FileOpenDialog("Wähle eine PDF-Datei", @ScriptDir, "PDF Files(*.pdf)", 3) ; put your own start folder here
										  If @error Then
											 MsgBox(64, "Hinweis", "Es wurde keine Datei ausgewählt")
										  Else
											 $oIE.navigate($sFile)
										  EndIf
									      ElseIf $g_iItem = "1001" Then
										     _GUICtrlTreeView_Expand($idTreeview, 0, False)
										  ElseIf $g_iItem = "1002" Then
										     _GUICtrlTreeView_Expand($idTreeview)
										  ElseIf $g_iItem = "1003" Then
										     $oIE.GoBack
										  ElseIf $g_iItem = "1004" Then
										     $oIE.GoForward
										  ElseIf $g_iItem = "1005" Then
										     $oIE.Refresh
										  ElseIf $g_iItem = "1006" Then
										     $oIE.Stop
										  ElseIf $g_iItem = "1007" Then
										     MsgBox(64, "Hinweis", "Funktion noch nicht integriert")
										  ElseIf $g_iItem = "1008" Then
										     $oIE.navigate(@ScriptDir & "\start\hilfe.pdf")
										  ElseIf $g_iItem = "1009" Then
										     Exit
										  EndIf
						   Case $TBN_HOTITEMCHANGE
								$tNMTBHOTITEM = DllStructCreate($tagNMTBHOTITEM, $ilParam)
								$iOld = DllStructGetData($tNMTBHOTITEM, "idOld")
								$iNew = DllStructGetData($tNMTBHOTITEM, "idNew")
								$g_iItem = $iNew
								$iFlags = DllStructGetData($tNMTBHOTITEM, "dwFlags")
					EndSwitch
		EndSwitch
    Return $GUI_RUNDEFMSG
EndFunc
#EndRegion ;**** --- ****
#Region ;**** Verzeichnisbaum erstellen ****
Func _CreateRoot(ByRef $idTreeview, $sPath, $bLargeIcons)
     Local $iIndex, $hItem, $sName
     $iIndex = _GUIImageList_GetFileIconIndex($sPath, $bLargeIcons, True)
	 $sName = StringRegExpReplace($sPath, '.+\\(.+)', '$1')
     $hItem = _GUICtrlTreeView_AddFirst($idTreeview, 0, $sName, $iIndex, $iIndex)
     $mPathMap[$hItem] = $sPath ; den Pfad anhand des Item-Handle speichern
     Return $hItem
EndFunc
#EndRegion ;**** --- ****

#Region ;**** Verzeichnis einlesen ****
Func _ReadDirectory(ByRef $idTreeview, $hItem, $sPath, $bLargeIcons)
    Local $iIndex, $aFolder, $aFiles, $hChild = $hItem, $sName
    If StringRight($sPath, 1) <> '\' Then $sPath &= '\'

    $aFolder = _WinAPI_EnumFiles($sPath, 2, $sExcludeDirs, True) ; nur Verzeichnisse einlesen
    If Not @error Then
        For $i = 1 To $aFolder[0][0]
            If Not BitAND($aFolder[$i][6], $FILE_ATTRIBUTE_REPARSE_POINT) And _
                    Not BitAND($aFolder[$i][6], $FILE_ATTRIBUTE_HIDDEN) Then
                $sName = StringRegExpReplace($sPath & $aFolder[$i][0], '.+\\(.+)', '$1')
                $iIndex = _GUIImageList_GetFileIconIndex($sPath & $aFolder[$i][0], $bLargeIcons, True)
                $hChild = _GUICtrlTreeView_AddChild($idTreeview, $hItem, $sName, $iIndex, $iIndex)
                $mPathMap[$hChild] = $sPath & $aFolder[$i][0] ; den Pfad anhand des Item-Handle speichern
                _ReadDirectory($idTreeview, $hChild, $sPath & $aFolder[$i][0], $bLargeIcons)
            EndIf
        Next
    EndIf
    _WinAPI_SetCursor($hBusyCur ? $hBusyCur : 9)
    $aFiles = _WinAPI_EnumFiles($sPath, 1, $sFileExtensions) ; nur Dateien einlesen
    If Not @error Then
        For $i = 1 To $aFiles[0][0]
            If Not BitAND($aFiles[$i][6], $FILE_ATTRIBUTE_HIDDEN) Then
                $sName = StringRegExpReplace($sPath & $aFiles[$i][0], '.+\\(.+)\..+', '$1')
                $iIndex = _GUIImageList_GetFileIconIndex($sPath & $aFiles[$i][0], $bLargeIcons, True)
                $hChild = _GUICtrlTreeView_AddChild($idTreeview, $hItem, $sName, $iIndex, $iIndex)
                $mPathMap[$hChild] = $sPath & $aFiles[$i][0] ; den Pfad anhand des Item-Handle speichern
            EndIf
        Next
    EndIf

EndFunc
#EndRegion ;**** --- ****

#Region ;**** Imageliste für Verzeichnisbaum (Treeview) erstellen ****
Func _GUIImageList_GetFileIconIndex($sFilePath, $bLargeIcons = False, $bForceLoadFromDisk = False)
    Local $tFileInfo = DllStructCreate($tagSHFILEINFO)
    Local $iFlags = BitOR($SHGFI_SYSICONINDEX, _
            $bLargeIcons ? $SHGFI_LARGEICON : $SHGFI_SMALLICON, _
            $bForceLoadFromDisk ? 0 : $SHGFI_USEFILEATTRIBUTES)
    Local $ret = _WinAPI_ShellGetFileInfo($sFilePath, $iFlags, $FILE_ATTRIBUTE_NORMAL, $tFileInfo)
    If $ret Then Return DllStructGetData($tFileInfo, 'iIcon')
    Return SetError(1, 0, -1)
EndFunc
#EndRegion ;**** ---****

Func PSPropertyKeyFromString($sPropKey)
	Local $tProp = DllStructCreate("byte fmtid[16]; dword pid;")
	Local $aCall = DllCall("propsys.dll", "long", "PSPropertyKeyFromString", "wstr", $sPropKey, "struct*", $tProp)
	If @error Or $aCall[0] Then Return SetError(1, 0, $tProp)
	Return $tProp
EndFunc   ;==>PSPropertyKeyFromString

Func ObjectFromTag($sFunctionPrefix, $tagInterface, ByRef $tInterface)
	Local Const $tagIUnknown = "QueryInterface hresult(ptr;ptr*);" & _
			"AddRef dword();" & _
			"Release dword();"
	; Adding IUnknown methods
	$tagInterface = $tagIUnknown & $tagInterface
	Local Const $PTR_SIZE = DllStructGetSize(DllStructCreate("ptr"))
	; Below line really simple even though it looks super complex. It's just written weird to fit one line, not to steal your eyes
	Local $aMethods = StringSplit(StringReplace(StringReplace(StringReplace(StringReplace(StringTrimRight(StringReplace(StringRegExpReplace($tagInterface, "\h*(\w+)\h*(\w+\*?)\h*(\((.*?)\))\h*(;|;*\z)", "$1\|$2;$4" & @LF), ";" & @LF, @LF), 1), "object", "idispatch"), "variant*", "ptr"), "hresult", "long"), "bstr", "ptr"), @LF, 3)
	Local $iUbound = UBound($aMethods)
	Local $sMethod, $aSplit, $sNamePart, $aTagPart, $sTagPart, $sRet, $sParams
	; Allocation. Read http://msdn.microsoft.com/en-us/library/ms810466.aspx to see why like this (object + methods):
	$tInterface = DllStructCreate("ptr[" & $iUbound + 1 & "]")
	If @error Then Return SetError(1, 0, 0)
	For $i = 0 To $iUbound - 1
		$aSplit = StringSplit($aMethods[$i], "|", 2)
		If UBound($aSplit) <> 2 Then ReDim $aSplit[2]
		$sNamePart = $aSplit[0]
		$sTagPart = $aSplit[1]
		$sMethod = $sFunctionPrefix & $sNamePart
		$aTagPart = StringSplit($sTagPart, ";", 2)
		$sRet = $aTagPart[0]
		$sParams = StringReplace($sTagPart, $sRet, "", 1)
		$sParams = "ptr" & $sParams
		DllStructSetData($tInterface, 1, DllCallbackGetPtr(DllCallbackRegister($sMethod, $sRet, $sParams)), $i + 2) ; Freeing is left to AutoIt.
	Next
	DllStructSetData($tInterface, 1, DllStructGetPtr($tInterface) + $PTR_SIZE) ; Interface method pointers are actually pointer size away
	Return ObjCreateInterface(DllStructGetPtr($tInterface), "", $tagInterface, False) ; and first pointer is object pointer that's wrapped
EndFunc   ;==>ObjectFromTag

Func _Ribbon_Create($hWnd, $hRibInstance, $sResName, ByRef $oRibbFramework, ByRef $oApp, ByRef $oHandlers)
	#forceref $oHandlers
	; Win7 and above
	$oRibbFramework = ObjCreateInterface($sCLSID_UIRibbonFramework, $sIID_IUIFramework, $tagIUIFramework)
	If Not IsObj($oRibbFramework) Then Return False
	Local Static $tObj
	$oApp = ObjectFromTag("_MyUIApp_", $tagIUIApplication, $tObj)
	$oRibbFramework.Initialize($hWnd, $oApp())
	$oRibbFramework.LoadUI($hRibInstance, $sResName)
EndFunc   ;==>_Ribbon_Create

Func _Ribbon_Destroy(ByRef $oRibbFramework, ByRef $oApp, ByRef $oHandlers)
	; Release all created objects
	$oRibbFramework.Destroy()
	$oRibbFramework = 0
	$oApp = 0
	For $i = 0 To UBound($oHandlers) - 1
		$oHandlers[$i][0] = 0
		$oHandlers[$i][1] = 0
	Next
EndFunc   ;==>_Ribbon_Destroy

;********************************************************************************************;
; Define UIApplication methods
Func _MyUIApp_QueryInterface($pSelf, $pRIID, $pObj)
	ConsoleWrite("_MyUIApp_QueryInterface called" & @CRLF)
	Local $tStruct = DllStructCreate("ptr", $pObj)
	Switch _WinAPI_StringFromGUID($pRIID)
		Case $sIID_IUnknown, $sIID_IUIApplication
			DllStructSetData($tStruct, 1, $pSelf)
			ConsoleWrite("IUnknown" & @CRLF)
			Return 0 ; S_OK
	EndSwitch
	ConsoleWrite(@CRLF)
	Return 0x80004002 ; E_NOINTERFACE
EndFunc   ;==>_MyUIApp_QueryInterface

Func _MyUIApp_AddRef($pSelf)
	#forceref $pSelf
;~ 	ConsoleWrite("_MyUIApp_AddRef called" & @CRLF)
	Return 0
EndFunc   ;==>_MyUIApp_AddRef

Func _MyUIApp_Release($pSelf)
	#forceref $pSelf
;~ 	ConsoleWrite("_MyUIApp_Release called" & @CRLF)
	Return 0
EndFunc   ;==>_MyUIApp_Release

Func _MyUIApp_OnCreateUICommand($pSelf, $iCommandId, $iCommandType, $pHandler)
	#forceref $pSelf, $iCommandId, $iCommandType
;~ 	ConsoleWrite("_MyUIApp_OnCreateUICommand called" & @CRLF)
	$tHandler = DllStructCreate("ptr", $pHandler)
	If Not $pHandler Then Return 0x80004003 ; E_POINTER
	Local Static $i = 0
	ReDim $oHandlers[$i + 1][2] ; resize the array
	Local $oNewHandler = ObjectFromTag("_MyHandler_", $tagIUICommandHandler, $oHandlers[$i][1])
	$oHandlers[$i][0] = $oNewHandler ; save new object
	$i += 1
	DllStructSetData($tHandler, 1, $oNewHandler())
	Return 0 ; S_OK
EndFunc   ;==>_MyUIApp_OnCreateUICommand

Func _MyUIApp_OnDestroyUICommand($pSelf, $iCommandId, $iCommandType, $pHandler)
	#forceref $pSelf, $iCommandId, $iCommandType, $pHandler
;~ 	ConsoleWrite("_MyUIApp_OnDestroyUICommand called" & @CRLF)
	Return 0 ; S_OK
EndFunc   ;==>_MyUIApp_OnDestroyUICommand

Func _MyUIApp_OnViewChanged($pSelf, $iViewId, $iTypeId, $pView, $iVerb, $iReason)
	#forceref $pSelf, $iViewId, $iTypeId, $pView, $iVerb, $iReason
;~ 	ConsoleWrite("_MyUIApp_OnViewChanged called" & @CRLF)
	Return 0 ; S_OK
EndFunc   ;==>_MyUIApp_OnViewChanged
;********************************************************************************************;


;********************************************************************************************;
; Define UICommandHandler methods
Func _MyHandler_QueryInterface($pSelf, $pRIID, $pObj)
;~ 	ConsoleWrite("_MyHandler_QueryInterface called" & @CRLF)
	Local $tStruct = DllStructCreate("ptr", $pObj)
	Switch _WinAPI_StringFromGUID($pRIID)
		Case $sIID_IUnknown, $sIID_IUICommandHandler
			DllStructSetData($tStruct, 1, $pSelf)
			Return 0 ; S_OK
	EndSwitch
	Return 0x80004002 ; E_NOINTERFACE
EndFunc   ;==>_MyHandler_QueryInterface

Func _MyHandler_AddRef($pSelf)
	#forceref $pSelf
;~ 	ConsoleWrite("_MyHandler_AddRef called" & @CRLF)
	Return 0
EndFunc   ;==>_MyHandler_AddRef

Func _MyHandler_Release($pSelf)
	#forceref $pSelf
;~ 	ConsoleWrite("_MyHandler_Release called" & @CRLF)
	Return 0
EndFunc   ;==>_MyHandler_Release

Func _MyHandler_Execute($pSelf, $iCommandId, $iVerb, $pKey, $vCurVal, $pProps)
	#forceref $pSelf, $iVerb, $pKey, $vCurVal, $pProps
;~ 	ConsoleWrite("_MyHandler_Execute called " & $iCommandId & "    $vCurVal = " & $vCurVal & @CRLF)
	Switch $iCommandId
		Case 1001
			 Global $sFile = FileOpenDialog("Wähle eine PDF-Datei", @ScriptDir, "PDF Files(*.pdf)", 3) ; put your own start folder here
					If @error Then
						MsgBox(64, "Hinweis", "Es wurde keine Datei ausgewählt")
					Else
						$oIE.navigate($sFile)
					EndIf
		Case 1002
			_GUICtrlTreeView_Expand($idTreeview, 0, False)
		Case 1003
			_GUICtrlTreeView_Expand($idTreeview)
		Case 1004
			$oIE.GoBack
		Case 1005
			$oIE.GoForward
		Case 1006
			$oIE.Refresh
		Case 1007
 			$oIE.Stop
		Case 1008
 			MsgBox(64, "Hinweis", "Funktion noch nicht integriert")
		Case 1009
 			$oIE.navigate(@ScriptDir & "\start\hilfe.pdf")
		Case 1010
			Exit ;MsgBox(64, "Action Browser", "Start Browser or something", 0, $hGUI)

	EndSwitch
	Return 0 ; S_OK

EndFunc   ;==>_MyHandler_Execute

Func _MyHandler_UpdateProperty($pSelf, $iCommandId, $pKey, $vCurVal, $vNewVal)
	#forceref $pSelf, $iCommandId, $pKey, $vCurVal, $vNewVal
;~ 	ConsoleWrite("_MyHandler_UpdateProperty called" & $iCommandId & "    $vCurVal = " & $vCurVal & "    $vNewVal = " & $vNewVal & @CRLF)
	Return 0 ; S_OK
EndFunc   ;==>_MyHandler_UpdateProperty
;********************************************************************************************;


; Helper functions:
Func _ReadColor($iCommandId)
	Local $tPKEY = PSPropertyKeyFromString($sUI_PKEY_Color)
	Local $iColor
	$oRibbFramework.GetUICommandProperty($iCommandId, $tPKEY, $iColor)
	Return Dec(Hex(BinaryMid($iColor, 1, 3))) ; AGBR to RGB
EndFunc   ;==>_ReadColor

Func _ReadFontSize($vVar)
	Local $iSize = 9
	Local $tVARUnk = DllStructCreate($tagVARIANT, $vVar)

	Local $oPropertyStore = ObjCreateInterface(DllStructGetData($tVARUnk, "data"), $sIID_IPropertyStore, $tagIPropertyStore)
	If @error Then Return $iSize
	$oPropertyStore.AddRef()

	Local $tPKEY = PSPropertyKeyFromString($sUI_PKEY_FontProperties_Size)

	$oPropertyStore.GetValue($tPKEY, $iSize)

	Return $iSize
EndFunc   ;==>_ReadFontSize

Func _ReadFontWeight($vVar)
	Local $iWeight = 400
	Local $tVARUnk = DllStructCreate($tagVARIANT, $vVar)

	Local $oPropertyStore = ObjCreateInterface(DllStructGetData($tVARUnk, "data"), $sIID_IPropertyStore, $tagIPropertyStore)
	If @error Then Return $iWeight
	$oPropertyStore.AddRef()

	Local $tPKEY = PSPropertyKeyFromString($sUI_PKEY_FontProperties_Bold)

	$oPropertyStore.GetValue($tPKEY, $iWeight)

	Return $iWeight * 400
EndFunc   ;==>_ReadFontWeight

Func _ReadFontAttrib($vVar)
	Local $iAttrib = 0
	Local $tVARUnk = DllStructCreate($tagVARIANT, $vVar)

	Local $oPropertyStore = ObjCreateInterface(DllStructGetData($tVARUnk, "data"), $sIID_IPropertyStore, $tagIPropertyStore)
	If @error Then Return $iAttrib
	$oPropertyStore.AddRef()

	Local $tPKEY, $iItalic, $iUnderline, $iStrikethrough

	$tPKEY = PSPropertyKeyFromString($sUI_PKEY_FontProperties_Italic)
	$oPropertyStore.GetValue($tPKEY, $iItalic)
	If $iItalic = 2 Then $iAttrib += 2
	$tPKEY = PSPropertyKeyFromString($sUI_PKEY_FontProperties_Underline)
	$oPropertyStore.GetValue($tPKEY, $iUnderline)
	If $iUnderline = 2 Then $iAttrib += 4
	$tPKEY = PSPropertyKeyFromString($sUI_PKEY_FontProperties_Strikethrough)
	$oPropertyStore.GetValue($tPKEY, $iStrikethrough)
	If $iStrikethrough = 2 Then $iAttrib += 8

	Return $iAttrib
EndFunc   ;==>_ReadFontAttrib

Func _ReadFontFamily($vVar)
	Local $sFamily = ""
	Local $tVARUnk = DllStructCreate($tagVARIANT, $vVar)

	Local $oPropertyStore = ObjCreateInterface(DllStructGetData($tVARUnk, "data"), $sIID_IPropertyStore, $tagIPropertyStore)
	If @error Then Return $sFamily
	$oPropertyStore.AddRef()

	Local $tPKEY = PSPropertyKeyFromString($sUI_PKEY_FontProperties_Family)

	$oPropertyStore.GetValue($tPKEY, $sFamily)

	Return $sFamily
EndFunc   ;==>_ReadFontFamily

Func _GetGlobalColor()
	Local $oPropertyStore = ObjCreateInterface($oRibbFramework(), $sIID_IPropertyStore, $tagIPropertyStore)
	If @error Then Return SetError(1, 0, 0)
	$oPropertyStore.AddRef()
	Local $tPKEY = PSPropertyKeyFromString($sUI_PKEY_GlobalBackgroundColor)
	Local $iColor
	If $oPropertyStore.GetValue($tPKEY, $iColor) Then Return SetError(2, 0, 0)
	Return $iColor
EndFunc   ;==>_GetGlobalColor



